{-
% cv. 10 ; na 26.4.2017 (St) ; Jan Hric
% v. 1.1

% Obsah: cv10:
...

; prejmenovat na *.hs , 
taky .lhs : filter1, lookup1

.lhs vyzaduje prazdne radky okolo kodu zacinajiciho '>'

-}

{-
-- vzor

> filter1 :: (a -> Bool) -> [a] -> [a]
> filter1 _ []     = []
> filter1 f (x:xs) = if f x then x:filter1 f xs
> 			    else   filter1 f xs

test:
filter1 even [1,2,3,4,5]
-}


{-

Naprogramujte:

1. filterWithLast :: (a->Bool) -> [a] -> [a]
Vraci prvky podle podminky a posledni prvek

2. concat :: [[a]] -> [a]  -- z prelude
Spoji seznam seznam do jednoho seznamu. 
Vlastne prevod matice na vektor.

volani:
concat [[1,2],[3],[],[4,5]]
 ~> [1,2,3,4,5]

3. Kartezsky soucin
kart :: [a] -> [b] -> [(a,b)]

3a. primo rekurzi
3b. skladanim funkci: map, concat, ...


4. tridyEkv :: (a -> a -> Bool) -> [a] -> [[a]]
Funkcionalni (prvni) parametr popisuje relaci ekvivalence.
Funkce tridyEkv/2 rozdeli vstupni seznam na tridy ekvivalence

5. merge :: (a->a->Bool) -> [a] -> [a]
Merge z mergesortu. Fnc. arg. predava porovnavani.
- Pro procviceni @

(5b. mergesort, sude, liche, rozdel ... )

6. testovani komutativity:
testKom :: Num b => (a->a->b) -> [(a,a)] -> Bool
Testuje na danem seznamu (dvojic) vstup, jestli zadana operace je komutativni.

Co se pripadne hodi:
6a. and :: [Bool] -> Bool  - z prelude
and/1 je n-arni and

6b. all :: (a-> Bool) -> [a] -> Bool	-- z prelude
all/2 vraci, jestli pro vsechny prvky plati podminka
all even [2,4,0,-2]
 -> True
- and pomoci all

-- podobne:
or :: [Bool] -> Bool	-- z prelude
 - n-arni or
any :: (a-> Bool) -> [a] -> Bool	-- z prelude
 - aspon pro jeden prvek plati podminka

z cv., Q: jak je definovano: and []
A: Vhodne, aby to davalo smysl. A analogicky k "or []", coz je prazdna klauzule, 
kterou znate z logiky. 
Deklarativne chceme, aby: or xs == or [] || or xs . 
 -- podrobneji: or xs == or ([]++xs) == or [] || or xs
Tj. "or []" je neutralni prvek pro binarni (||).


7. lookup1: vyhledavani klice, kdyz tam je 
lookup1 :: a -> [(a,b)] -> b
- nepokryty vzor, zde prazdny seznam: zpusobi behovou chybu

> lookup1 x ((y,val):ys) | x==y = val
>                        | True = lookup1 x ys

- pouziti: prekladova tabulka pro Cezarovu sifru (posun pismena o 3), 
	preklad pomoci map/2

- tabulkaCezar vyrobi prekladovou tabulku, s danym posunutim: zip
- sifrujCezar sifruje podle tabulky: map + lookup1
- tabulkaDesifr: map
  - Cv: premenit sifrovaci tabulku na desifrovaci ; pomoci map
- cyklPosun n xs: "pootoci" dany retezec xs o n znaku (smerem dopredu)
- a klasicky deklarativni test: ta2 (ta1 txt) == txt 
    ; tj. sifrovani a nasledne desifrovani vrati puvodni text (a jako slozeni funkci je identita)

> tabulkaCezar :: Int -> [a] -> [(a,a)]  	-- vyrobi tabulku
> tabulkaCezar n xs = zip xs (cyklPosun n xs)

> sifrujCezar :: Eq a => [(a,b)] -> [a] -> [b]	-- typ je obecny, az pri pouziti je b = String
> sifrujCezar tab plainText = map (\ x -> lookup1 x tab) plainText

> cyklPosun :: Int -> [a] -> [a]
> cyklPosun n xs = drop n xs ++ take n xs  -- {n>=0}

> tabulkaDesifr :: [(a,b)] -> [(b,a)]
> tabulkaDesifr tab = map (\(x,y) -> (y,x)) tab

> tabulkaCezar3 :: [(Char,Char)]
> tabulkaCezar3 = tabulkaCezar 3 "abcdefghijklmnopqrstuvwxyz"


> ta1 text = sifrujCezar (tabulkaCezar3 ) text
> ta2 text = sifrujCezar (tabulkaDesifr tabulkaCezar3) text


8. Nasobeni matic, kdyz mame sks/2: skalarni soucin
 - reprezentace vstupu , chytre
 - dalsi maticove operace



----------------------------------------------------------
cv. 9:

-- nestihli jsme
6. Fibonacciho cisla, pomocna fce z dvojic na dvojice
-}
--  fib n = n-te fib. cislo, n>0, indexovano od 1
fib :: Integer -> Integer
fib n = fst (fib1 n (1,0))

fib1 :: Integer -> (Integer,Integer) -> (Integer,Integer)
fib1 1  f1f0  = f1f0
fib1 n  f1f0  = fib1 (n-1) (transformujFib f1f0)

transformujFib :: (Integer,Integer) -> (Integer,Integer) 
transformujFib (f2,f1) = (f1+f2,f2)

-- co se hodi, z prelude
-- fst :: (a,b) -> a
-- fst (x,y) = x

-- muzeme pouzit fci nKratF


{-
-----------------
Priste, mozna:

7. lookup1: vyhledavani klice, kdyz tam je 
lookup1 :: a -> [(a,b)] -> b

8. kartezsky soucin
kart :: [a] -> [b] -> [(a,b)]

9. test komutativity, 
co se hodi: (all :: (a-> Bool) -> [a] -> Bool)

 

%%%%%%%%%%%%%%%%%%%%
% souhrn: co jste si vyzkouseli:
% - @
% - funkcionalni parametry
    - lambda funkce
% - specializace funkci, skladani funkci

------------------------------
-- ruzne
suma1 :: [Integer] -> Integer
suma1 [] = 0
suma1 (x:xs) = x + suma1 xs

length1 :: [a] -> Integer
length1 [] = 0
length1 (x:xs) = 1 + length1 xs



-----------------------------------------------
Z minulych let:

- klouzavy prumer ze 3
  - klouzavy prumer z n
- mergesort, sude, liche, merge
- testKomut
  - kartezsky soucin
- filter
- tridy ekv.
- lookup, zjednoduseny
- automaty (2x), reprezentace DKA vs. NKA, krok
- (rychle umocnovani)
- (FFT)

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% runtime
-}

