% cv. 5 ; na 22.3.2017 (St) ; Jan Hric
% v. 1.2.1

% Obsah: cv5 

% opakovani
% logicke formule
%   operatory
%   eval
% heapsort
%
% --
% vyhledavani, i slozene (?)
% idiom: interpret
% stromy: i n-arni

% zbylo (z cv4): kartezsky soucin
% - i indexovana varianta



%%%%%%%%%%%%%%%%%%%%% Opak.
% priprava adresare
% :- cd('c:/moje'). % s doprednymi lomitky, a s diskem c:
% oznam adresare
% :- pwd.
% kolik mate a potrebujete pameti ...
% :- statistics.

%%%%%%%%%%%%
% prunik/3, mod (+,+,-)
% - 3 moznosti, z prednasky 
%   - a) podminka na (B)  ; nevyhoda: test 2x
%   - b) rez na (A)       ; mene prehledne, nedeklarativni
%   - c) 2. a 3. klauzule spolu pomoci if->then;else ; 
% - spravnost vuci backtrackingu, viz priklad
% - prunik usporadanych mnozin, viz dale

% chybny prunik/3: prvni reseni je OK, ale pak vydava dalsi nespravna reseni
% - problem je, ze pri backtrackingu se pouzije i treti klauzule, 
%   protoze neobsahuje podminku (straz)
%   - treti klauzule je deklarativne nespravne (v kontextu procedury s rezem "!" muze fungovat)
prunik([],_,[]).
prunik([X|Xs],Ys,[X|Vs]) :- 
  member(X,Ys),     % (A)
  prunik(Xs,Ys,Vs).
prunik([_X|Xs],Ys,Vs):- % (B)
  prunik(Xs,Ys,Vs).

% podobne se muze rozbehnout i nekonecny cyklus, kdyz spatne osetrite podminku pro rekurzi

tf2(V):- prunik([1,2,3],[4,2,1],V).


%%%%%%%%%%%%%%%%
% interpret mnozin ; 
% vyhodnocovani (konstantnich) mnoz. vyrazu evalSet/2, evalSet(+MnVyraz, -V) 
% operatory \-/ /-\ \-- pro sjednoceni, prunik, rozdil respektive
%   - a symetricky rozdil, unarni union, ...
% a koncova podminka, s kontrolou

% ?- evalSet([1]\-/[2]/-\[3]\--[4],V).

% zavedeni operator
% - operatory op/3 jsou direktivy pro prolog; nechceme je vkladat do db.
%   -> radek zacina :- anebo ?- (stejne jako pro consult)
%   :- op(precedence, typ, jmeno).
% - operatory usnadnuji zapis funkcnich i predikatovych symbolu, 
%   ale nezavadi zadnou semantiku
%   -> po nacteni je d.s. stejna jako ta z prefixniho zapisu
% - priorita vs. precedence: vyssi matematicka priorita vic vaze, odpovida to 
% 	nizsi precedenci a poloze niz ve stromu/termu
%   - vzhledem k uz definovanym operatorum, pouzivaji se precedence okolo 300 pro termy

% :- op(precedence, typ, /-\).

% CV: definujte operatory:
% \--/ union unarni, s nejvyssi (matematickou) prioritou, opakovatelny
% /-\ prunik binarni s mensi (matematickou) prioritou, asoc. doprava
% \-- mnozinovy rozdil, binarni s mensi prioritou, asoc. doleva
% -\- symetricky mnoz. rozdil, binarni se stejnou prioritou, neasociativni
% \-/ sjednoceni, s nejmensi prioritou, asoc. doprava 
 
% test:
% tf3(_) :- display([1]\-/[2]/-\[3]\--[4]).

% navrh d.s. 
% - seznamy jdou dobre odlisit, ale muzeme zavest tag pro mnoziny m/1, pro promenne p/1
%   (podobne jako u eval na prednasce)
%   - take m/1 a p/1 muzete zavest jako operatory

% ?- evalSet1(m([1])\-/m([2])/-\m([3])\--m([4]),V). % zapis s operatory

seznam([]).
seznam([_|_]).
vstup2Mn(X,X). % zjednodusene 

evalSet(S,S0) :- 
  seznam(S),	% kontrola druhu/tagu (A)
  vstup2Mn(S,S0). % uprava na korektni tvar, vystup je bez opakovani ...
%evalSet(S1/-\S2,V) :-
 evalSet(/-\(S1,S2),V) :-
  evalSet(S1, V1),
  evalSet(S2, V2),
  prunik(V1,V2,V). % opravit prunik vyse.

% (A) podminka chrani i proti tomu, aby klauzule zpracovala slozene mnoz. vyrazy

%tf3(V) :- evalSet([1,2,3]/-\[3,2,5,1]/-\[4,2,1],V).
% syntakticky OK az po zavedeni operatoru 

% Q: ve vstupnim vyrazu (mnozinovem, vyrokovem ...) pri pouziti operatoru muzou byt zavorky.
% pr: ?- evalSet( ([1,2,3]\-/[3,2,5,1]) /-\ [4,2,1],V).
% Q: Jak osetrime zavorky ve strukturalni rekurzi?
% Q: je vhodne/mozne/vyhodne/spravne pouzit nasledujici klauzuli?
% evalSet( (VF1), V) :-
%   evalSet( VF1, V).  
% A: ...

% ad koncova podminka:
% varianta: zpracovani multimnozin
% - A) reprezentace: [a,a,b,b,c,b]
%   - a) semanticke operace prunik, sjednoceni ... to musi _spravne_ zvladnout (<- nezvladnou)
%   - b) koncova podminka kontroluje jine vlastnosti
% - B) reprezentace: [a-2,b-3,c-1] ; tj. histogram/cetnosti
%   - potrebujeme jine operace pro novy datovy typ
% varianta: usporadane mnoziny
% - operace jsou rychlejsi, ale jine
% - trade-off: diky usporadanym vstupum mame rychlejsi operace, ale musime 
%	vytvaret i usporadane vystupy, :-) samozrejme
% - koncova podminka evalSet/2, tj. vstup2Mn/2 prevede lib. vstup na spravny interni tvar
%   - uzivatel netusi, ze to mate usporadane (a nema tusit), 
%   - a i kdyz mu to v dokumentaci napisete, zapomene nebo udela chybu ... 
% - slozitost neusporadaneho pruniku, ... je O(n^2), usporadaneho O(n), pro n-prvkove seznamy

% jine vyrazy:
% vektorove, maticove, ...
% specialni aritmetika zbytkovych trid


%%%%%%%%%%%%%%
% eval vyrokove formule, z prednasky
% CV: tautologie Tau, lin, tj. pomoci splnitelnosti sat/1 z prednasky
%   <- z logiky: negace Tau je nesplnitelna
%   - nebo vhodnym pouzitim eval/1 s negaci non/1
%     ; zdarma mame hledani reseni, tj. ex. kvantifikator, nikoli univerzalni kv.


% cast eval/2, z prednasky
% predpokladam vhodnou definici operator (jejich kod je zakomentovany), zaveden jen operator and/2
:- op(210, xfy, [and]).  % def. operatoru and/2
eval(Ohod, VF1 and VF2, V):-	% diky operatoru syntakticky projde
  eval(Ohod, VF1, V1),
  eval(Ohod, VF2, V2),
  evalAnd(V1,V2,V).
% bez operatoru musime psat: 
% eval(Ohod, and(VF1,VF2), V) :- ...

eval(Ohod, p(X), Val) :- member(X-Val,Ohod).	% promenne
eval(Ohod, non(VF1), V) :-
  eval(Ohod, VF1, V1),
  evalNon(V1,V).
eval(Ohod,or(VF1,VF2), V) :-
  eval(Ohod, non(non(VF1) and non(VF2)), V).

evalNon(true,false).
evalNon(false,true).
evalAnd(true,true,true).
evalAnd(true,false,false).  
  % varianta: evalAnd(_,false,false). -> evalAnd/3 se splni opakovane, pro (false,false,V)
evalAnd(false,_,   false).

% vyhodnoceni: eval imp/2, ekv/2:

% eval imp/2:
% prevedeme na and, or, non, abychom nemuseli psat rekurzi a tabulku pro evalImp/3
% - anebo napiseme rekurzi a evalImp/3 pomoci prevedeni, viz dale
% eval(Ohod, VF1 imp VF2, V) :- ...


% eval ekv/2:
% a) prevedeme, ale ...
/*    * /
eval(Ohod, VF1 ekv VF2, V) :-
  eval(Ohod, VF1 and VF2 or non VF1 and non VF2, V).
/ *   */
%   - bez tabulky pro evalEkv/3, ale VF1 a VF2 se vyhodnocuji 2x -> to nechceme
% b) trade-off: rekurzi vyhodnotime explicitne (jednou), vysledky dosadime do formule
/*    * /
eval(Ohod, VF1 ekv VF2, V) :-
  eval(Ohod, VF1, V1),
  eval(Ohod, VF2, V2),
  eval(_Ohod, V1 and V2 or non V1 and non V2, V). % pouzivame vysledky
/ *   */
% pozn: v  a) se podformule zdileji -> pametova narocnost vzroste o nove vytvorenou cast
%   - az vyhodnocovani trva, protoze prochazi formule opakovane
%   - dalsi upravy VF bez ekv/2 (jako prevod do CNF) ji typicky opakovane skopiruji 
%     -> vysledek je reprezentovan jako term (s opakovanim), potrebna pamet se zvetsi

% dalsi ulohy (z minulych let)
% cv: pozbirani promennych z VF
%   - dve moznosti
% cv: odstraneni imp a ekv z VF (mezikrok k CNF/DNF)
% cv: propagace non/1 dolu k literalum
%       - analyza 2 urovni struktury
% cv: prevod na DNF, na CNF
% - dalsi: ...

/*
% neuplne struktury:
  - vhodnejsi a mene nebezpecny zpusob pouziti neuplnych datovych struktur 
    v kontextu vyhodnocovani eval/3 je, fixovat tvar struktury a jmena promennych a 
    nechat volne promenne pro hledane hodnoty
  - tvar tabulky: [a-Va, b-Vb]
    - potrebujeme pozbirat promenne z VF, 
    - vytvorit ohodnoceni (pomoci map/3) s volnymi hodnotami
    - volat eval/3
  - "jednoduche" programovani s omezenimi/constraint programming: 
    - nekolik vyskytu promenne ve VF musi zdilet stejnou hodnotu
    - urcita forma generuj a testuj (generujeme implicitne castecne stavy d.s.)
*/

tf4(V):- V=[a-_Va,b-_Vb],eval(V,non(p(a)) and p(b),true). 

tf5(V):- V=[a-_Va,b-_Vb],eval(V,non(p(a)) and p(b),false). 
% vysledky odpovidaji def. evalAnd/3: _Vb je neurcene (nezalezi na nem)



%%%%
% generovani ohodnoceni pro eval
% - idiom: generuj a testuj
% d.s.: ohodnoceni: [a-Va,b-Vb]
% - pomoci indexovaneho kart. soucinu
% ?- iKartN([a-[true,false],b-[true,false]], -Ohod).  
%  - mody a typy: iKartN(+[x-[val]],-[x-val])
%    - a, b, x jsou jmena promennych
%  - podobne: generovani moznych obarveni grafu
%  - ale: pametove narocne

% tf1(X) :- ... % cv5

% na rozmysleni: heapsort, nestihli jsme

% DCv: na dalsi roky, ne 2017:
% - 1) rozdil/3 (neusporadanych) histogramu, vcetne vypusteni x-0
% - 2) a symetricky rozdil, vhodnym pouzitim 1)


%%%%%%%%%%%%%%%%%%%%
% souhrn: co jste si vyzkouseli (nebo meli zvladnout):
% - rez, negaci, if->then;else
%   - deklarativne spravne klauzule, spravnost vuci backtrakingu
% - idiom: interpret
% - operatory: deklarace, pouziti
% - zpracovani termovych (tj. stromovych) struktur
% - ...

%%%%%%%%%%%%%%%%%
% zbylo z cv5

% generuj a testuj
% rozdilove seznamy na vystupu (quicksort)
% - na vstupu "ukusovani" vstupu (heapsort)

%%%%%%%%%%%
% jednoduche trideni
% insertSort/2
% selectSort/2

%%%%%%%%%%%%%%%%%%%%%%%%%%
% heapsort (s binarni haldou)
% - postav tvar heapu, zhalduj, vybirej
%   - vyuziva rozdel/3
%   - stavba: prvek pro vrchol utrhnu hned
% - stavba: doleva doprava
% - hned stavet haldu (rozdel a panuj)
%   - minimum do korene a zbytek rozdelit
%   - stavba v O(n log n)
%   - klasika je postavit 2 subhaldy a potom 1 prvek vlozit
% - kapitansky krok: hloubka je porad logaritmicka
%   - (ani) pri vybirani nemusim udrzovat vyvazenou haldu
%     - posledni halda je neuplna 
%   - vybirani v O(n log n)

%%%%%%%
% compare/3:
% - idiom: vysledky jako data
% podobne: v Prologu pouzivane uspeje/neuspeje jsme v eval/3 
%   nahradili explicitnim true/false (a eval/3 vzdy uspeje)
% podobne: vysledky misto backtrackingu vracime jako seznam reseni


%%%%%%%%%%%%%%%%%%%%%%%%


/*  * /
/ *
*/


%%%%%%%%%%%%%%%%%%%%
% souhrn: co jste si vyzkouseli:
% -


%%%%%%%%%%%%%%%%%%%%%%%%%%%
% runtime
check(Tested,=,Pattern) :- 
  Tested = Pattern -> write(passed),nl
                   ;  write(error),nl, 
		      write(value__(Tested)),nl, 
		      write(expected(Pattern)),nl.

%----------------

% k.
