-- \data\pgm
{-
% cv. 13 add ; na 21.5.2018 (Po) ; Jan Hric
% v. 1.1 
; *.hs

modul pro celociselnou aritmetiku "mod 17", pro FFT
 - jmeno souboru "Z17.hs" se musi shodovat se jmenem modulu "Z17" (a byt v path)
 - vzor syntaxe pro: 	1) modul, newtype, instance, deriving, 
			   ++ a "import" v kodu c13_17.hs
                     	2) urceni typu u konstanty: 17 :: Integer
			3) globalni funkce mInv, mapZ17, lift2Z17
 - styl: 4) konstanta c17
	 x) kazdy radek musi mit komentar 
 - 5) pocitani mInv naivne a pomalu

 - vyuka:
	6) definice nepouzitych procedur (abs, signum) musi byt pritomny,
	     i kdyz jsou prazdne; 
          6a) pouziti "undefined"
	7) operace jsou naprogramovany pomoci lift a map
	8) ve vyrazu "x*Z17 inv==1" v mInv se x a 1 prevede do typu Z17
	     pomoci fromInteger
	(9) syntax pro vytvoreni intervalu "[1..c17]" by sla definovat 
	     i pro typ Z17, pomoci typovych trid 
	     - v kodu je c17 :: Integer
-}

module Z17 where		-- 1

--data Z17 = Z17 Int
newtype Z17 = Z17 Integer	-- 1
	deriving (Eq,Ord,Read,Show)	-- 1

c17 = 17::Integer		-- 2,4

instance Num Z17 where		-- 1
  (+) = lift2Z17 (+)		-- 7
  (-) = lift2Z17 (-)		-- 7
  (*) = lift2Z17 (*)		-- 7
  negate = mapZ17 negate	-- 7
  --fromInt x = Z17 (x `mod` c17)
  fromInteger x = Z17 (x `mod` c17)	-- ref:8

  abs    = undefined		-- 6,6a
  signum = undefined		-- 6


mInv x = head [ Z17 inv | inv <- [1..c17], x * Z17 inv == 1]	-- 3,5,8

mapZ17 f(Z17 x) = Z17 (f x `mod` c17)				-- 3
lift2Z17 op (Z17 x) (Z17 y) = Z17 ((x `op` y) `mod` c17)	-- 3

-- end
